import java.io.IOException;

import com.ptc.cipjava.*;
import com.ptc.pfc.pfcSession.*;
import com.ptc.pfc.pfcGlobal.*;
import com.ptc.pfc.pfcCommand.*;

public class Launcher {
	public static String MSG_FILE = "messages.txt";

	public static void start() throws jxthrowable {
		Session currentSession = pfcSession.GetCurrentSessionWithCompatibility (CreoCompatibility.C4Compatible);

		String commandString = currentSession.GetMessageContents(
            MSG_FILE, "-L.launcher.cmd", null);
		String iconFile = currentSession.GetMessageContents(
            MSG_FILE, "-L.launcher.ico", null);

		UICommand cmd = currentSession.UICreateCommand("launcher",
				new MenuButtonListener(commandString, currentSession));
		cmd.SetIcon(iconFile);
		cmd.Designate(MSG_FILE, "-L.launcher.label", null, null);
		currentSession.UIAddButton (cmd, "File", null, "-calc launcher", "launches calc app", MSG_FILE);
	}

	public static void stop() { /* EMPTY */ }
}

class MenuButtonListener extends DefaultUICommandActionListener {
	private String commandString;
    private Session currentSession;

	public MenuButtonListener(String cmd, Session session) {
		commandString = cmd;
        currentSession = session;
	}

	public void OnCommand() throws jxthrowable {
		try {
			ProcessBuilder pb = new ProcessBuilder(commandString);
			pb.start();
		} catch (IOException e) {
			currentSession.UIShowMessageDialog(
                "Could not start " + commandString, null);
		}
	}
}